
// some C++14 news - demo
// g++ -std=c++14
// Public domain

#include <iostream>
#include <vector>
#include <algorithm>

// C++14 auto function return type:
auto max(int a, int b) { return (a>=b)?a:b; }

// C++14 designated initializers, binary literals, 'delimiters:
struct S { int field1; char field2; }
s { .field1=0b1110'10101010'10111010, .field2='a' }; // order is important

// C++14 template variables:
template<typename T> T var;
//template<> int var<int> = 0;          // optional explicit instantiation
//template<> double var<double> = 0.0;

template<typename C>
auto sum(C & c) {
  using T = typename C::value_type; // dependent type
//  var<T> = 0;   // template variable instantiation
  for(T x: c)
    var<T> += x;
  return var<T>;
}

int main() {
    std::vector<int> v{9,2,7,4,8};
    std::vector<double> d(begin(v),end(v));
    d.push_back(0.1);
    // C++14 auto lambda parameters:
    auto mylambda = [](auto x, auto y){return x>y;};
    std::sort(begin(v),end(v),mylambda);
    std::sort(begin(d),end(d),mylambda);
    std::cout << sum(v) << "\t" << var<int> << "\n";
    std::cout << sum(d) << "\t" << var<double> << "\n";
    std::cout << var<float> << "\n";    // instantiation, default value
}

