
// inspired by: cppreference.com

#include <vector>
#include <array>
#include <set>
#include <iostream>

#define PRINT(x) std::cout << "(" #x "): " << (x) << '\n'

int main()
{
    // EDIT: uncomment single container type
    const std::array    // CTAD: automatic deduction of <int>
//    const std::vector
//    const std::set
        a{1, 2, 3},
        b{1, 2, 3},
        c{7, 8, 9};     // std::array operator <=> needs the same size (type)

        std::cout << std::boolalpha;
        std::cout << "Compare equal containers:\n";
        PRINT(a != b);
        PRINT(a == b);
        PRINT(a < b);
        PRINT(a <= b);
        PRINT(a > b);
        PRINT(a >= b);
        PRINT((a <=> b) == std::weak_ordering::less);
        PRINT((a <=> b) == std::weak_ordering::equivalent);
        PRINT((a <=> b) == std::weak_ordering::greater);
        PRINT((a <=> b) < 0);
        PRINT((a <=> b) == 0);
        PRINT((a <=> b) > 0);

        std::cout << "Compare non equal containers:\n";
        PRINT(a != c);
        PRINT(a == c);
        PRINT(a < c);
        PRINT(a <= c);
        PRINT(a > c);
        PRINT(a >= c);
        PRINT((a <=> c) == std::weak_ordering::less);
        PRINT((a <=> c) == std::weak_ordering::equivalent);
        PRINT((a <=> c) == std::weak_ordering::greater);
        PRINT((a <=> c) < 0);
        PRINT((a <=> c) == 0);
        PRINT((a <=> c) > 0);
}
