
// std::pair default operator <=>

#include <algorithm>
#include <iomanip>
#include <iostream>
#include <string>
#include <utility>
#include <vector>
#include <tuple>

int main()
{
    // simple sorting example
    std::vector<std::pair<int, std::string>> v = {{2, "baz"}, {2, "bar"}, {1, "foo"}};
    std::sort(begin(v), end(v));
    for (auto p : v)
        std::cout << '{' << p.first << "," << std::quoted(p.second) << "}\n";

    // another example for 3-tuple
    std::vector<std::tuple<int,std::string,float>> v2{
        {2, "baz", -0.1},
        {2, "bar", 3.14},
        {1, "foo", 10.1},
        {2, "baz", -1.1},
    };
    std::sort(v2.begin(), v2.end());
    for (const auto& p: v2)
        std::cout << "{ " << std::get<0>(p)
                  << ", " << std::get<1>(p)
                  << ", " << std::get<2>(p)
                  << " }\n";
}

