
// CRTP example
// source: Wikipedia
// TODO: +copy_count? +new_count?

#include <iostream>

template <typename T>
struct counter
{
    static inline int objects_created = 0;
    static inline int objects_alive = 0;

    counter()
    {
        ++objects_created;
        ++objects_alive;
    }

    counter(const counter&)
    {
        ++objects_created;
        ++objects_alive;
    }
    int alive() const { return objects_alive; }
protected:
    ~counter() // objects should never be removed through pointers of this type
    {
        --objects_alive;
    }
};

class X : counter<X>    // private inheritance
{
    int x;
    // ...
  public:
    using counter<X>::alive;
};

class Y : counter<Y>
{
    int y;
    // ...
  public:
    using counter<Y>::alive;
};


X x;
Y y;
int main() {
    X x;
    std::cout << x.alive() << "\n";
    std::cout << y.alive() << "\n";
}
