
// C++17
// inspired by cppreference.com

#include <array>
#include <vector>
#include <iostream>
#include <type_traits>

struct A {
    int m;
    void f() {}
};

int A::*memberdata_ptr = &A::m;     // a pointer to member data
void (A::*memberfun_ptr)() = &A::f; // a pointer to member function

#define TEST(x) \
    (std::cout << "is_pointer_v<" #x "> == " \
               << std::is_pointer_v<x> << '\n')

int main()
{
    std::cout << std::boolalpha;
    TEST(A);
    TEST(A*);
    TEST(A const* volatile);
    TEST(A&);
    TEST(decltype(memberdata_ptr));
    TEST(decltype(memberfun_ptr));
    TEST(void*);
    TEST(int);
    TEST(int*);
    TEST(int**);
    TEST(int[10]);
    TEST(std::nullptr_t);
}

