
// source: cppreference.com

#include <iostream>
#include <memory>

std::weak_ptr<int> gw;

void observe()
{
    std::cout << "gw.use_count() == " << gw.use_count() << "; ";
    // we have to make a copy of shared pointer before usage:
    if (std::shared_ptr<int> spt = gw.lock())
        std::cout << "*spt == " << *spt << '\n';
    else
        std::cout << "spt==" << spt << "  (gw is expired)\n";
}

int main()
{
    {
        auto sp = std::make_shared<int>(42);
        gw = sp;
        observe();
        // sp destructor call
    }
    // invalid target
    observe();
}

