
// inspired by: Stroustrup: Programming Principles and Practice Using C++, 2ndEd

#include <iostream>
#include <random>
#include <vector>
#include <algorithm>
#include <ranges>

using namespace std;

void larger(vector<int> & v1, vector<int> & v2) {
    if(v1.size()!=v2.size()) throw "larger(): size difference";
    for(int i=0; i<v1.size(); ++i)
        if(v1[i]<v2[i])
            swap(v1[i],v2[i]);
}

void print(const vector<int> &v) {
    cout << "{ ";
    for(auto x: v)
        cout << x << ' ';
    cout << "}\n";
}

int main() {
    random_device rd;   // true random generator
    mt19937 g{rd()};    // pseudorandom generator, random seed
    uniform_int_distribution<int> dist(-9, 9); // transform
    const int n = 10;
    vector<int> v1(n);
    vector<int> v2(n);
//    ranges::generate(v1,g);
    ranges::generate(v1,[&](){return dist(g);});
    iota(begin(v2),end(v2),0);
//    shuffle(begin(v2),end(v2),g);
    print(v1);
    print(v2);
    larger(v1,v2);
    cout << '\n';
    print(v1);
    print(v2);
}
